=== debian/changelog ===
biosig4c++ (0.96.3+svn2677-2) unstable; urgency=low

  * up_for_loop_initial patch to prevent FTBFS. Thanks Aurelien Jarno for
    report and patch (Closes: #633346)

 -- Yaroslav Halchenko <debian@onerussian.com>  Sat, 09 Jul 2011 10:40:56 -0400

biosig4c++ (0.96.3+svn2677-1) unstable; urgency=low

  * Initial release (Closes: #585533)
  * Ship and use a copy of eventcodes.txt from biosig project
  * Patches added:
    - up_system_octave_version to build against default available
      version of octave
    - deb_no_mex_copy_upstairs to not try copy resultant .mex files
      outside of the tree
    - deb_link_dynamically* to assure dynamic linking against the library
    - deb_no_locals to avoid errorneous linking against /usr/local

 -- Yaroslav Halchenko <debian@onerussian.com>  Thu, 05 May 2011 12:28:27 -0400

biosig4c++ (0.94.2+svn2552-1~pre1) UNRELEASED; urgency=low

  * New upstream snapshot: some API extensions in the library interface
  * Assure linking of .so against used libraries
  * Symlinks for the missing manpages

 -- Yaroslav Halchenko <debian@onerussian.com>  Fri, 29 Oct 2010 00:58:54 -0400

biosig4c++ (0.94.1+svn2521-1~pre0) UNRELEASED; urgency=low

  * Initial Debian packaging.

 -- Yaroslav Halchenko <debian@onerussian.com>  Fri, 11 Jun 2010 01:19:48 -0400
